/*ar787-feather 2xhtu31d 2xwifi
Vers- see below
Started- 23 Feb 23

Arduserver: A device to read sensors and make the reading available
in a page of HTML. See...
https://sheepdogguides.com/ardsrv/
for a full guide to the idea.
There is a wide range of open source code available to you there.

*** SEE (tut qURL) for lots of help with setting this up ***

None of the next three is a "deal breaker". They merely put documentation I
  find useful into the compiled code.*/
String sPrgmName="ar787-2at312wifi";//Filename identifying this "sketch" (program/app).
String sInstance="(Your h/w ID gies here)";//ID of which specific Arduino this was compiled for
String sHTMLTitle="ICH09v-Arduserver by wywtk.com<< can be what you want";//This will be used in
  //HTML <title>, and thus affect the text on the tab in some browers.
String sVersID="4 Mar 2023-12:30";//Version... can say more than just datestamp
//but datestamp saves you having to keep track of serial numbers.
// ^ ^ ^ All of the above: "Instance Specific"
/*Things marked "instance specific" may need tweaking any time you
create a new instance of this device. (ctrl-f is a quick way to find them)*/

//The following doesn't "matter"... it can be true or false. It just changes
//(slightly) how much information goes to the serial monitor. Setting it false
//will not interfere with any basic functions.
const boolean boVerboseMMsgsWanted=true;
#define VerboseMessagesOn
/*You may want de-rem the above (Or rem it out, if you find it remmed at
    the moment). The code will work fine either way. Don't be afraid of
  the #define if it isn't an old friend... use ctrl-f to find the lines
  with VerboseMessagesOn and all will be revealed!*/

/*=======
This is able to work on two wifi LANs (not at the same time!)
And you need to know that it will go on your LAN at a specific IP
    address, and use a specific port to serve webpages. Both chosen by you
If you want to make a new instance of this device, you will need to put
    the wifi creds address, etc into the code. (ne set is enough, if
    you only want to use it in one place!)
YOU MUST "edit" THIS CODE to change those things. But you only need to change
    things up here at the top of the code.... E.g. the place you "set" the IP
    address has the following has "bLIPA0a=192;" in it.

The declarations for setup() and loop() are at the top of all the subroutine
    (SR) declarations. Study them, if you would understand how this works. The
    rest is "details"... which ARE available, but be clear about what's in
    setup() and loop() before you try to understand anything the details.*/

/*It is written so that you should be able to build it up, get it working, in
    stages. You don't need "everything" working before you can get ANY result.*/

/*Trying to make one of these, and can't even read the sensors, let alone get
the device to serve a web page? Your cable may be too long. Or "not the right
sort". Get the code to read the sensors working reliably before starting work
on the wifi things. (In the early "just read the sensors" state, you can see
the sensor readings in the serial monitor. (For help on "serial monitor":
  https://sheepdogguides.com/arduino/aht1serimoni.htm
I have a badly bodged 60cm cable that WORKS and a nice, neat,
commercially sources 50cm ribbon cable with crimped-on connectors which doesn't.

Start with a nice commercial SHORT I2C cable... 10cm? (Buy two, while shopping.)

The cable you want (for the Adafruit HTU31D, anyway) is sold as a "Qwiic" or
"STEMMA QT". (A "STEMMA" (no "QT") cable is SOMETHING ELSE.) Sigh. But at least 
Sparkfun and Adafruit are playing nicely together.

When you've got that working, try... shudder... cutting it in half and soldering
in a length of some other cable. I used alarm cable... the pairs weren't even 
twisted. (Twisted may be better... put the +ve and Gnd in one pair, SDA, SCL in
the other.) Cat5 cable is another candidate... and you can make TWO
"long" I2C cables from one length of Cat5, can't you?! Mayve useful...

 https://electronics.stackexchange.com/questions/438859/should-i-twist-dc-power-and-ground-wires-from-a-power-supply
 
---
ARGH!!!! udrSensor all mixed up! I have one udrSensor0, and FOUR things in it,
instead of 2x2. Sigh It all WORKS... but it needs sorting out, to make the code
ELEGANT!...
There is a "Things to do" in a section futher down the page.

---
What's with the arcane name, "r787-feather 2xhtu31d 2xwifi" ???...

This is my ARduino program ("sketch" if you prefer) nubmer 787 (no, I haven't
used all of 0-786!), it is for (hardware) a FEATHER huzzah 8266, and
reads *TWO* (*TIMES*, two of them) HTU31D sensors, and sends a page
HTML out from a webserver (part of ar787), via Wifi.

The extra "2x" was meant to indicate that each HTU31D reads two things...
Temperature and humiduty.

Not my Best Name Ever. Sorry.

/*
*** HELP, PLEASE!!!???... If I accidentally posted a copy of this
*** code *with* my Wifi creds, please let me know where it is posted??
*/

/*
Pins used... See notes in
  SendWelcomeAndDocumentationToSerialMonitor()

---
To some extent, you can "pick and choose" what elements you
want to include in what YOU want to do.

It was designed to be a flexible starting point.

In particular, you can change what sensors the device monitors.

---
Before you worry about what bits you want, study the following,
  so that you understand what is here, what is available to you...

What it does, as is:
  It reads two HTU-31D temperature/ humidity sensors
  It passes the values to the serial monitor. (Or the display of you devising)
      (If infamiliar with "serial monitor" see
           https://sheepdogguides.com/arduino/aht1serimoni.htm
  It makes the values read available via the webserver that is also
      in the code, un the Feather Huzzah.

An effort was made to make it easy to change WHAT sensors are read.
An effort was made to make it easy to "unplug" the webserver element.

------
To adapt for you own purposes...

If you don't need I2C services, lines that can be dropped are marked. (They
  are only needed to read the sensors this was written for.
If you are reading different I2C devices, you will have to dig a bit in the code.

If you don't need the webserver element, remove or rem out all of the material
  marked as "for wifi", or "for webserver".

If you DO want the webserver element, you need to know that this is written on
  the assumption that you will use a static IP for the device. (A static IP within
  your LAN. Your router can, as usual, have a dynamic IP address.)

Still on "if you want webserver..."... you will, as is usual, have to set various
  things like what static IP address you want and wifi creds. An effort has been
  made to make it easy for you to recode the software to supply those data.
*/ 
 
//================================================================
/*====== BEGINNING OF: ---Section "Big section: Things to Do" ---- 

ADD WINK CODES!!! M/R LINE

---
Give any instance of this an ink-on-paper label saying that a message 
is sent via serial monitor **at 9600 baud** on reset.*

---
I2C: PULL-UPS (1K) on SDA and SCL ***CAN HELP***!!!... maybe.
  They DID... once anyway.
 (Without them, readings can be bad.)

---Section "Big section: Things to Do"        *** ENDS *** === */
//===============================================================

// v v v Three below: "Instance Specific"
#define pinMsgsByLedFlash 0 //It would be sensible to use the
  //onboard LED for this. On a Feather Huzzah, that is on D0
#define pinAlwaysLow 15 //Pin number in name as these pins are 
#define pinSelectWifi 14 //  mentioned in documentation, by number
//16 didn't work for this... 15 couldn't pull it down very far. And strange
//   things happened anyway when link was in place. Wasn't ignoreed, but
//   neither did "boot with other wifi creds" happen. (And when I JUST
//   changed to using 14... all went well! (^_^)
//It is unusual to include something like the "14" in something like
//   pinSelectWifi. It degrades the efficiency of USING names.
//   In this case, I wanted to help the user 
//WRITE UP: 16 not as simple as it seems. Even allowing for info at
//   Adafruit page... https://learn.adafruit.com/adafruit-sht31-d
//     -temperature-and-humidity-sensor-breakout  

#include <Wire.h>//to allow use of I2C
#include "Adafruit_HTU31D.h"//for Adafruit temperature/humidity sensor.
  //Use Tools/ Manage Libraries to install. See the following if
  //  more help needed... https://github.com/adafruit/Adafruit_HTU31D

#include <ESP8266WiFi.h>//needed to use wifi 

#include "Tkb23227_1stLib.h";//Only needed in connection with  generating
//the page of HTML that is available if you use wifi elements of this.
//Doesn't need to be "installed" in your IDE... just keep copies of...
//  Tkb23227_1stLib.h and Tkb23227_1stLib.cpp
//in the same folder as you .ino file.
//Indulge me?... This is a scrap left behind to celebrate the
//   day I made my 1st Arduino library... a step up I should have
//   made LONG ago. My EASY succes was all thanks to the very
//   VERY good introduction in...
//   https://roboticsbackend.com/arduino-create-library/
//   The following, if put in setup() demonstrated
//      that my first library, Tkb23227_1stLib.h was working...
//      Serial.print(addTwoInts(3,5));    ! ! ! (^_^)
//
//The library supplies a few funtions you can perfectly well put in
//the main page, i.e. the one you are reading!
//*** USING YOU OWN LIBRARIES is a WONDERFUL aid to Doing Things Well,
//  and brings no end of BENEFITS. Well worth the very small amount of
//  trouble to master the skill. See....
// https://roboticsbackend.com/arduino-create-library/
//... which not only has the right stuff, but is Very Well Written.

//The next is part of what you need to read the HTU31-D sensor. Mysterious?
//I think so too! But It Works. Also see the comments below teh two lines...
Adafruit_HTU31D htu   = Adafruit_HTU31D();
Adafruit_HTU31D htu41 = Adafruit_HTU31D();
/*The above are actually a little like the more familiar...
String sVersID="vers 24 Feb 25-11:30";
... with which we created a variable: sVersID
  of a particular TYPE: "String"
  ... and gave it an initial value: "vers 24 Feb 23-06:00"
"htu", "htu41" are "variables" we create with these lines.
The other parts of the lines "just work", thanks to things
  in the Adafruit_HTU31D.h library.
The "initial value" fills bits of htu, htu41 with various good
  initial values. Note that it is THE SAME for both "variables",
  no distinction is made between htu, htu41*/

//Variables with "tmp" ("temporary") in the name are for short
//  term, narrow scope use. Do not expect anything in such a one to persist.
//("temperature" will be abbreviated "tture".)
String sTmp;
byte bErrCode;//Remember: Type "byte" is UNsigned. It can hold 0-255
  //Not enough it done with bErrCode yet. More should be done, but the
  //  gaps are not stopping the program from working when all is well.
int iTmp,iPassesSinceStrt,iPortU;//Type "int" is signed. 16 or 32 bit,
//            depending on processor
//boolean boWeAreUsing1stSetOfCreds;
boolean boLEDState=true,boWeAreUsing1stSetOfCreds;
unsigned long liMillisRecent;//"Millis recently" might be a better name!
  //It will be reasonably up to date. It will be no further behind
  //  than when the main loop was most recently re-started
int iSerialBaud=9600;//This is for the SerialMonitor.

// are obsolte, can be written out...
const byte bLEDOn=0;//These are the values for digitalWrite to the
const byte bLEDOff=1;//  output the LED is on. Which makes it on, 0 or
//1 depends on how the LED was wired to the circuit. On,off/0,1 is
//right for pinMsgsByLedFlash

//Move to a part more clearly aobut config?
//Introduce a bLedOnPin (consistent with other pin names)? Eschew "pinMsgsByLedFlash"?
boolean boMakeHiToTurnOn=true;//set true if making the pin high makes LED go on.

/*=========
 "Unnecessary" frill BEGINS... but used for a reason!!!
 This will greatly simplify tweaking this code if you want to work
   with a different set of sensors on your device.
 My first Arduino "struct"!...
 Thank you https://forum.arduino.cc/t/using-struct/42793/2 */

//If sensors in system change, the inner parts of the following
//   will need changes.
//As it stands, this was badly done. But by the time I realized
//   this it would have meant re-writing too much. (I should have
//   put only ONE tture, one humidity in the structure, and used
//   TWO instances of TudrSensorData... one for each sensor. Duh.
//YOU can re-write it thus! It would be good practice for how you
//   would re-program the code to accomodate different sensors!
//Note to self: When you set about fixing this, start with what's
//   in the loop()SR
struct SudrSensorData
{
    String sSensorUnitsTture;
    String sSensorUnitsHum;
    float fTture0;
    float fTture1;
    float fHum0;
    float fHum1;    
};

typedef struct SudrSensorData TudrSensorData;

TudrSensorData udrSensorData0;//Creates an instance...
/*The code now has a "variable" called usrSensorData0
 Now, elsewhere in the code, I can have things like:
   TudrSensorData udrSensorData0; <create instance
   udrSensorData0.sSensorUnits1 = "testing, testing";
This was DUMB coding... see note above. The note with
"struct SudrSensorData..."

END OF this part of "Unnecessary" frill*/

//================================================================
//===START section "Big block of Wifi related items..."-----------
//If you don't aspire to having your device be a 
//    webserver, you don't need these
//
// WiFi Definitions ** SOME MUST BE TWEAKED FOR YOUR LOCATION ** //
//

WiFiServer server(80);//This says it is going to be on port 80.
/*Don't worry... we can change that later. But it needs SOMETHING.
It was late. I was tearing hair. I'd spent ages trying to get around
a "Catch-22" connected with this. After MANY hours in quest of
"switchable" creds/settings, and much progress, it seemed this issue
might have made all my work pointless. But then I found...
https://github.com/esp8266/Arduino/issues/2128#issuecomment-357142507 
SAVED MY SANITY. It told me "Set the object up using whatever
port you like... but add ([port num]) to your server.begin, and that
will give you a server on THAT port!!! HURRAH!!!
 */

/*Here we supply TWO SETS ofthe various parameters for our WiFi
connection. Much of the code's documentation refers to what's
here as the "WiFi creds", but, as you can see, what you can set
goes WAY beyond SSID and password.
Which set you get depends on whether a connection ("link" has been made between
the pins called pinAlwaysLow and pinSelectWifi */
const char kSet1Label[] = "1st set";char kSet2Label[] = "2nd set";
//
//Uses FIRST set if there is NO link. If logic changed, change Welcome message
//If your SSID includes spaces, you MAY need to preceed them with \'s. Let me know?!
const char WiFiSSIDa[] = "(ssid of your first wifi here)";//   (Change other part of creds, too,
  // ^ "Instance Specific"                  if data here changed)
  //By "instance" I mean the circumstances of a particular wifi LAN and this device's
  // connection to it. The code will need to be tweaked, and re-compiled, sent to
  // whatever Arduino you want to use for a particular place.
const char WiFiPSKa[] = "(password of your 1st wifi here)";
  // ^ "Instance Specific"  v v v as are the following!... v v v
//CAREFUL: set BOTH bLIPA3a(and -b), AND bLIPAa(and -b)...
//                             bLIPA2a/b is sometimes 0, sometimes 1!
const byte bLIPA0a=192;const byte bLIPA1a=168;
               const byte bLIPA2a=1;const byte bLIPA3a=125;  
const int iPortA=80;  
const byte bGate0a=192;const byte bGate1a=168;
               const byte bGate2a=1;const byte bGate3a=1;  
const byte bMask0a=255;const byte bMask1a=255;
               const byte bMask2a=255;const byte bMask3a=0;  

//v v v v  Alternate set of WiFi creds, etc...  v v v v

const char WiFiSSIDb[] = "(ssid of your second wifi here)";
  // ^ "Instance Specific"                
const char WiFiPSKb[] = "(password of your second wifi here)";
  // ^ "Instance Specific"
const byte bLIPA0b=192;const byte bLIPA1b=168;
                const byte bLIPA2b=0;const byte bLIPA3b=180;  
const int iPortB=1234;
const byte bGate0b=192;const byte bGate1b=126;
                const byte bGate2b=0;const byte bGate3b=0;  
const byte bMask0b=255;const byte bMask1b=255;
                const byte bMask2b=255;const byte bMask3b=0;  
  // ^ End of "Instance Specific" material                
//*/


/*HELP, PLEASE!!!???... If I accidentally posted a copy of this
code *with* my Wifi creds, please let me know where it is posted??
*/

/*The following may be "overkill", but I wanted everything that would
need tweaking to create a new instance of the device to be here near
start of the code.

The following determine...
  what the device's Local IP Address ("LIPA") will be. (It's IP in the LAN)
  what local IP addr is used for the device's gateway
  and the LAN's subnet mask. (All of this is IPv4 only)

bLIPA0,-1, and -2 determine the first three numbers in BOTH the
device's LIPA and that of the first three for the gateway.
(If you know of a LAN that allows these to be different, do tell!)

The final number for the device's LIPA is supplied with bLIPA3
The final number for the gateway's LIPA is supplied with bLIPA_Gateway
Not rocket science!

SubNet0,-1, -2 and -3 determine... can you guess?... the LAN's subnet mask.

If you want...
  Device's LIPA to be 192.168.0.123 then set...
    bLIPA0=192, bLIPA1=168, bLIPA2=0, bLIPA3=123
If you want...
  Gateway's LIPA to be 192.168.0.1 then set...
    bLIPA0=192, bLIPA1=168, bLIPA2=0, bLIPA_Gateway=1
If you want subnet mask of 255.255.255.0, then set...
  bSubNet0=255, bSubNet1=255, bSubNet2=255, bSubNet3=0*/

//Further wifi related items...
String sMsg;//Wifi related. Remember: There are two easily muddled data
     //types: String and string. This must be String, upper case "S".

//---END of "Big block of Wifi related items"========



//=======================================================
//== ++++ ==  setup() AND loop().... section  === ++++====
//
//  The declarations of setup() and loop() are at the top of
//    all the SRs. The rest are in a following block, where
//    they are in alphabetical order, except as explained there

//=================================  setup() ==========

void setup() {
  
iPassesSinceStrt=0;

InitPinModes();//SEE NOTES in SendWelcomeAndDocumentationToSerialMonitor

Serial.begin(iSerialBaud);//Get ready to send things to serial monitor.
//"Serial monitor"?. See https://sheepdogguides.com/arduino/aht1serimoni.htm
while (!Serial) {delay(10);} //Wait for serial port to finish opening

delay(200);
//Don't try to write to the serial monitor too soon. 
    //What you try to send may get lost!
    //
    //When working on the code, sometimes pressing the "reset" button on
    //the Arduino AFTER uploading the newest code will "fix" problems with
    //output that should be appearing in the serial monitor.
    
SendWelcomeAndDocumentationToSerialMonitor();//Details are in SR

bErrCode=bSetUpSensors();

//You may still get some gibberish in the serial 
//   monitor before the message you should get appears.
//   This is something I've stuggled with, unsuccessfully,
//   (obviously) for YEARS! Sigh. Anyone know the answer??
//
//NEEDS MORE WORK, especially in respect of what is returned
//  in bErrCode, and what is then done with it!
  Serial.print("SetupSensors reported: ");
  Serial.println(bErrCode);

//Do I want "did it set up okay?" reports here?? Can I tell??

boWeAreUsing1stSetOfCreds=(boUseFirstSetofCreds());
//(We need the result from the function again later, too)

if (boWeAreUsing1stSetOfCreds)
 {iPortU=iPortA;}//no ; here
 else
 {iPortU=iPortB;};

server.begin(iPortU);//Part of creating the webserver.
//Essential "ingredient" of webserver code. Remembering
//that was last "gotcha" of big 2/23 effort. When, yet AGAIN,
//I attempted to access the server this code should create,
//I did so with NO feeling of anticipation! I'd been worn
//down to the point of expecting "Connection timed
//out... cannot  connect"!
//
//But! Never undaunted, Mr Murphy stepped up and immediatley
//caused a weird seize-up of the PC I was using. It did't take
//a full re-boot to get running again, but it was a scary moment!
//(Task Manager sees the Arduino IDE as "Java(TM) Platform...", by
//the way.)

//
//NEEDS WORK: *** Can we test that the "begin" was successful??

ConnectWiFi();//only needed if you need the wifi service
}  //end setup()  -----------------------------------------------



//==================================  loop() ==========
void loop() {
  liMillisRecent=millis();//This may... or may not... be updated
    //elsewhere, too.
  iPassesSinceStrt=iPassesSinceStrt+1;
 
  //If sensors in system change, the following will need
  //  to be reconsidered. These are HTU31 specific.
  sensors_event_t humidity,temp;//Specific to using HTU31 sensors
  sensors_event_t humidity41,temp41;
  
  //Following also HTU31 sensor specific
  htu.getEvent(&humidity,&temp);//You can't(?) insert space in this line
  htu41.getEvent(&humidity41,&temp41);//   to make it "line up" with this.
  //I had an old note from somewhere that said spaces in the lines
  //above would(!) stop them working. Very odd. But that
  //was what the note said!
  //
  //If sensors in system change, the internals of the following will
  //     need changing.
  //
  //----
  //Would it make sense to create a "FillUdrSensorDataRecord" SR?
  //"UdrSensorDataRecord" A User Defined Record holding Sensor Data
  //.... not just recent readings, but also things like the units used.
  //
  //Some parts of .fTture0=temp that don't change are filled elsewhere
  udrSensorData0.fTture0=temp.temperature;
  udrSensorData0.fTture1=temp41.temperature;
  udrSensorData0.fHum0=humidity.relative_humidity;
  udrSensorData0.fHum1=humidity41.relative_humidity;
          
  //Provide proof of life and local report of readings...
  Serial.print(iPassesSinceStrt);
  SendReadingsToSerialMonitor(udrSensorData0);
  
  //From here until place marked: WiFi related...
  sMsg=sBuildMessage(iPassesSinceStrt,udrSensorData0);

  //------ HERE BEGINS....
  //A block where partly we are wasting time... but also,
  //while we do that, we are checking whether a client
  //has requested service. Call it a poor man's event
  //handler.

  //---- sub-unit...
  //Check if a client has connected, and if one has, deal with
  //  sending the webpage to it...  
  bErrCode=bOfferToServe(sMsg);//Related to using wifi to serve pages
  // ^ error code returned is meaningless as yet.
  delay(500);

  //---- sub-unit...
  //Check if a client has connected, and if one has, deal with
  //  sending the webpage to it...  
  bErrCode=bOfferToServe(sMsg);//Related to using wifi to serve pages
  // ^ error code returned is meaningless as yet.
  LedTurnOn(pinMsgsByLedFlash,boMakeHiToTurnOn);
  delay(90);
  LedTurnOff(pinMsgsByLedFlash,boMakeHiToTurnOn);
  //Can stay off now, until something else wants it
  //  on again (or we come back to line above it again.)
  delay(500);

  //---- sub-unit...
  //Check if a client has connected, and if one has, deal with
  //  sending the webpage to it...  
  bErrCode=bOfferToServe(sMsg);//Related to using wifi to serve pages
  // ^ error code returned is meaningless as yet.
  LedTurnOn(pinMsgsByLedFlash,boMakeHiToTurnOn);
  delay(90);
  LedTurnOff(pinMsgsByLedFlash,boMakeHiToTurnOn);
  //Can stay off now, until something else wants it
  //  on again (or we come back to line above it again.)
  delay(500);

  //---- sub-unit...
  //Check if a client has connected, and if one has, deal with
  //  sending the webpage to it...  
  bErrCode=bOfferToServe(sMsg);//Related to using wifi to serve pages
  // ^ error code returned is meaningless as yet.
  LedTurnOn(pinMsgsByLedFlash,boMakeHiToTurnOn);
  delay(90);
  LedTurnOff(pinMsgsByLedFlash,boMakeHiToTurnOn);
  //Can stay off now, until something else wants it
  //  on again (or we come back to line above it again.)
  delay(500);

  //---- sub-unit...
  //Check if a client has connected, and if one has, deal with
  //  sending the webpage to it...  
  bErrCode=bOfferToServe(sMsg);//Related to using wifi to serve pages
  // ^ error code returned is meaningless as yet.
  delay(500);

  //... END OF block where we waste time AND watch for clients
  
  //RETNINK!....
  //Report a complete pass through the loop with a flash of the LED.
  //When a serial monitor is attached, the line of data arising
  //  during a pass will suffice for that channel.
  
}  //end loop() -----------------------------------------




//=======================================================
//*******************************************************
//The remaining blocks in this code are listed below in
//alphabetical order, using every character found
//on the first line of the block. I.e byte's "b" in
//"byte bOffer, void's "v" in "void SendWelcome..."
//
//(A few excptions are made to alphabeitcal ordering.
//     They are explained in the places they arise.) 
//-------------------------------

//=======================================================
//====booleans ==========================================
//=======================================================
boolean boUseFirstSetofCreds()
//If there is NO link (which will let 14 flot HIGH,
//  use FIRST set of creds...
//Logic: The EASY route (no link) gives you FIRST set
{
  if (digitalRead(pinSelectWifi)==HIGH)/*Pulled high if
       there is NO external h/w link to 0v.*/ 
   {return true;}//no ; here
     else {return false;};
}// end of boolean boUsingFirstSetofCreds()

//====bytes =============================================
//=======================================================
byte bOfferToServe(String sHttpMsg) //Not *s*tring- *S*tring)
/* This routine taken "wholesale" from the excellent...  
https://arduino-esp8266.readthedocs.io/en/latest/esp8266wifi/server-examples.html
Any Good Stuff- all credit to the authors of that. (readthedocs accessed 25 Feb 23)
And then messed up by me! (T.K.Boyd, author of the code you find this in.)
See also >>> MY WEBPAGE (I need to insert link here. wywtk.com will do 'til I~ do<<<
*/
{
  // See if a client (web browser) trying to connect. Falls through, if no
  //   one queuing to get in.
  //In code that inspired this, next was: WiFiClient client = server.accept();
  //28 Feb 2023, 20:14,... a new problem arose... server had WORKED... but now suggesting Server (uc s)
WiFiClient client = server.available();
//WiFiClient clientB = serverB.available();
//WiFiClient clientU;16

  //See https://www.arduino.cc/reference/en/libraries/ethernet/server.available/
  //and https://forum.arduino.cc/t/server-available-problem/117342
  //and https://forum.arduino.cc/t/wificlient-client-server-available-fails/703298/2
  //and https://reference.arduino.cc/reference/en/libraries/ethernet/server.accept/
  //The "problem"?... When, 25 Feb 23, Arduino 1.8.13, I tried "accept", I got...
  //  'class WiFiServer' has no member named 'accept'; did you mean '_accept'?
  //If I understand these things, "available" is better ANYWAY! "accept" would see
  //  clients that merely CONNECTED, and then did nothing. I am only interested in
  //  clients that send an http request, and such clients ALWAYS send stuff.
  //".available", as I understand things, only "sees" clients wanting to send something!
  //  (^_^). (Using "accept" risks(?) spending time (getting into a do... while... loop that
  //  won't end) if a client JUST connects, and then does nothing with the connection.
  //SEND MESSSAGE ABOUT THIS TO readthedocs!

  //The following won't be of any use unless a server.begin was successfully executed earlier!
  //Doing that in setup() seems permissible.
  
  if (client)
  {
    Serial.println("\n[Client connected]");
    while (client.connected())
    {
      // read line by line what the client (web browser) is requesting
      if (client.available())
      {
        String line = client.readStringUntil('\r');
        Serial.print(line);
        // wait for end of client's request, that is marked with an empty line
        if (line.length() == 1 && line[0] == '\n')
        {
          //original was... client.println(prepareHtmlPage());
          client.println(sHttpMsg);//My version. Trivial change, as far
            //as the webserving is concerned. Just to do with different program
            //structure.(PrepareHtmlPage() was a subroutine in the original that
            //returned a type-String value)
          break;//Provides for "early" exit from "while (client.connected())".
                //Is there any way you could get STUCK inside that "while"???
                // ^ ^ ^ IMPORTANT! RESOLVE!!! ^ ^ ^ 
        }
      }
    }

    while (client.available()) {
      // but first, let client finish its request
      // that's diplomatic compliance to protocols
      // (and otherwise some clients may complain, like curl)
      // (that is an example, prefer using a proper webserver library)
      client.read();
    }

    // close the connection:
    client.stop();
    Serial.println("[Client disconnected]");
  }
  //Make value returned meaningful!
  return 99;
}  //end of byte bOfferToServe()

//=======================================================
byte bSetUpSensors() {
//If sensors in system change, the inner parts of the following
//   will need changes.

  udrSensorData0.sSensorUnitsTture="deg.Celsius";
  udrSensorData0.sSensorUnitsHum="% RH";

  //The "while (true) mechanism uses the Watchdog timer to
  //   get us out of a jam. See accompanying tutorial.
  if (!htu.begin(0x40)) {
    Serial.println("Couldn't find sensor on 40!");
    while (true);//"true"(all lower case. don't use "TRUE")
    }

  if (!htu41.begin(0x41)) {
    Serial.println("Couldn't find sensor on 41!");
    while (true);//"true"(all lower case. don't use "TRUE")
    }
  
  //Make value returned meaningful!
  return 5;
}  //end of byte bSetUpSensors

//==== strings ==========================================
//----------- OUT OF sequence, but goes with next....
String sMachineReadableData()
{
  String sTmpL,sBuildMachReadableData;

//In the following, the float in fTture0 is converted into a string.
float fTture0=udrSensorData0.fTture0;
float fTture1=udrSensorData0.fTture1;
float fHum0=udrSensorData0.fHum0;
float fHum1=udrSensorData0.fHum1;
  
  //1st one is =, not += for a good reason!
  sBuildMachReadableData=FloatPercentToFixedIntString(fHum0,2);//4.679% -> 0468  String(fHum0);//
  sBuildMachReadableData +=FloatToFixedIntString(fTture0,1,4);//12.38 -> +124, -4.444 _> -044
  sBuildMachReadableData +=FloatPercentToFixedIntString(fHum1,2);//4.679% -> 0468  String(fHum1);//
  sBuildMachReadableData +=FloatToFixedIntString(fTture1,1,4);
  sBuildMachReadableData +='b';//As yet unused single letter
  sBuildMachReadableData +=LongToFixedLengthString(liMillisRecent,10);//NEEDS WORK- should pre-vett for length, maybe chop.millis-10 digits
  return sBuildMachReadableData;
  } //end sMachineReadableData... out of sequence, as it goes with sBuildMessage

//=======================================================
String sBuildMessage(int iPasses, TudrSensorData udrSensorDataLocal) {
//^^^N.B.: "String", not "string"
  //          Both acceptable to Arduino, only String suits this job
  //Only needed for wifi features.
  //This builds the WHOLE of the message to be set off, HTTP style
  
  //If sensors in system change, the inner parts of the following
  //   will need changes.

byte bErrReturned=0;
  
//Prepare the response. Various elements added by TKB to Sparkfun demo>
//This has been done with more care than was necessary. Something
//  much simpler, for the core text, is possible.
//Start with the common header:
  String sToReturn= "HTTP/1.1 200 OK\r\n";
  sToReturn += "Content-Type: text/html\r\n\r\n";
  sToReturn += "<!doctype html><html lang=""en"">\n";

  sToReturn += "<head><title>"+sHTMLTitle+"</title>\n";
  sToReturn += "<meta http-equiv=\"Content-Type\" content=\"text/html;charset=utf-8\">\n";
  sToReturn += "<meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0\">\n";
 
  sToReturn += "<body>\n<h1 style=\"color:#0000cc;\">Welcome!</h1>";
  
  /*========== Here begins a somewhat arcane section
  //If sensors in system change, the inner parts of the following
  //   will need changes.

Besides being arcane, it is something of a dog's
  dinner 26 Feb 23.

  Before we feed the dog... some good documentation...
  
  This block adds some lines to th HTMP being built. The lines
  are comments... ordinary visitors to the page served won't
  see what's in them. But the contents are formatted to be
  read easily by other computers. See my "FarWatchWatcher" pages...
  http://sheepdogsoftware.co.uk/ssdd67.htm

  The format used is "understood" by one of my FW005 prgms:
  "FWDDS- Harvest data from HTTP server. Ver: Fork-of-31-
           Jan-19. Vers of fork:05 Mar 19."...
  ... which was watching 192.168.0.212:1202 at 26 Feb 23-
        NC Kitchen. It was returning...
  For THAT FarwatchWatcher, both the "hhhhsttthhhhstttb" line...
    (indication of format) and the next line, the line with
    data, had to be present. And the format line had to be
    the 8th line returned by the FarWatch Arduserver.

 I'm copying that (and adding to it) for ar787 so that I will
    have some FWW to use, at least until I can write a better
    one.
    
  Thing go downhill from here... but I hiope there's enough
    sense in the next bits to be useful...
    
       hhhhsttthhhhstttb  ... type data. (The "b" at the end
            was optional, for that, it seems, in older uses
            of this format. Pre-2023 uses.)
            
  Two samples of data that might be encountered...          
       0001+2450001+1971... or
       0001-0289999+3231

  hhhh: Could be any4 digit number! But I will use it here, for ar787, for %RH humidity * 100 (with 100% converted to
    99.99%)
  sttt: s: sign. ttt:digits. Here: tture in deg C * 10

  b: For ar787- ANY LETTER, either u/c or l/c. Reserved for future use in ar787 at the time
  of writing. 

  For ar787, I am adding 10 more digits, used for the latest result from millis().

  The following is a complete example of what the old FW Arduserver, the one the FWW
  could watch, might have had in the 7th, 8th and 9th lines of the webpage. (Pages
  counted as a human... or Textpad... would- 1st line: "line 1")
  N.B.... the last two lines would be visible even to casual visitors to
  the page, not hidden in comments as I generally prefer to do these days (2/23).
  
  <!--The next line must be the 8th line for some FarWatchWatchers<br>-->
  hhhhsttthhhhstttb
  0001+2450001+1271

  (Remember- at 2/23, the data is being expanded to add a further 10 digits.
  
  Enough documentation! Still poor material, but... It Should Work. (Re-write some day?)
  */
  
  //Insert five lines in the HTML. The first 3 are hidden from the ordinary reader of
  //the page. The last two, the ""machine frendly" version of the data, must be visible
  //to allow old-at-2/23 FWWs to read them. WHEN THOSE FWWs have been retired, this
  //report of the sensor readings in m/r form can be dropped from the code... WHEN YOU
  //DO THAT take out the use of sTmp that exists at the moment.
  sToReturn += "<pre style=\"color:#cc0099;\">\n<!--The next line must be line 8 (1st is line'1') for some FWW s/w-->\n";
  sToReturn += "hhhhsttthhhhstttb\n";
  sTmp=sMachineReadableData();
  sToReturn += sTmp+"\n";
  sToReturn += " latter part...  ^^^^^^^^^^  ... changes if the device is running.\n";
  sToReturn += " the Arduserver has run since it was last booted.\n</pre><br>\n";                
  sToReturn += "<!--See https://wywtk.com/fw/FarWOverview.htm ";
  sToReturn += "for an explanation of the previous few lines-->\n";
  sToReturn += "<!--The data line gives, twice...-->\n";
  sToReturn += "<!--  [ a) a tture (deg C x10) b) a humidity (%x100)]... in fixed width fields,-->\n";
  sToReturn += "<!--then a single character dataum... not currently active, and then-->\n";
  sToReturn += "<!--a number that goes up and up and up (until it rolls over... which it will).-->\n";
  sToReturn += "<!--(The source of this last number is a Work In Progress. It WORKS... but WHAT-->\n";
  sToReturn += "<!--the number is has not yet stabilized!-->\n\n";
  
  sToReturn += "<p>The two lines above are not meant for humans. They \n";
  sToReturn += "hold the current data in a machine-friendly form, for  \n";
  sToReturn += "<i>programs</i> which      access this device. The lines don't even \n";
  sToReturn += "need to be <i>visible</i> to the humans... except for \n";
  sToReturn += "the needs of some old software that I use to READ this page.<\p>\n\n";
  sToReturn += "<p>If you have a look at the source of this page (if you are \n";
  sToReturn += "viewing it via a web browser), you will see that similar lines \n";
  sToReturn += "are also present in a hidden form. The visible-to-humans lines \n";
  sToReturn += "will be removed in due course.</p>\n\n";
 
  sToReturn += "<!--Second m/r data block... this one NOT visible to visitors-->\n";
  sToReturn += "<!--who access the webpage with a browser. This will remain when-->\n";
  sToReturn += "<!--I am able to retire the visible-to-humans data block.-->\n";
  sToReturn += "<!--hhhhsttthhhhstttbxxxxx-->\n";
  sToReturn += "<!--"+sTmp/*sMachineReadableData()*/+"-->\n\n";
  /*  
  sToReturn += "<br>-->";
  sToReturn += "<br>-->";
  sToReturn += "<br>-->";
  */
 
  /* BEGIN BIG BLOCK OF SCRAPS TO BE TIDIED UP....
    
  //The second parameter to the String function determines the number
  //  of decimal places... BUT MUST NOT BE PRESENT unless the value
  //  being converted is a floating point number.
  //  (If you do String(234,0); you get "0".)
  */ 
  //sTmp=sFixedLen(6,String(4.5)/*1st tture goes here*/);
  /*   if (bErrReturned!=0) sTmp="ErrFrm sFixedLen:"+String(bErrReturned);
      sToReturn += sTmp+",";//-99.99 provided for
  */
  //sTmp=sFixedLen(6,String(x.5)/*1st humid goes here*/);
  /*   if (bErrReturned!=0) sTmp="ErrFrm sFixedLen:"+String(bErrReturned);
      sToReturn += sTmp+",";//-99.99 provided for
  */
  
  /* 
  sTmp="xx";//sFixedLen(6,String(humidity,2));
    if (bErrReturned!=0) sTmp="ErrFrm sFixedLen:"+String(bErrReturned);
    sToReturn += sTmp+"-->\n";//100.00 provided for
  */ 
  //sToReturn += "";
  
  //    \n";
  // sToReturn += "and 3 )  in fixed width fields.-->\n";
 
  //"millis" is max 10 chars... I checked!
  
  //sToReturn += sTmp;

  //... "BIG BLOCK OF SCRAPS TO BE TIDIED UP"  *** ENDS *** ====== */
  
  sToReturn += "\n<br>\n<hr>\n";
  sToReturn += "\n<h2 style=\"color:#0000cc;\">What the sensors see...</h2>\n";
  sToReturn += "<p>When the sensors last returned a result, the two humidities ";
  sToReturn += "monitored were...</p>\n";
  sToReturn += "<h4>&emsp;&emsp;";
  sToReturn += udrSensorDataLocal.fHum0;
  sToReturn += " and ";
  sToReturn += udrSensorDataLocal.fHum1;
  sToReturn += udrSensorDataLocal.sSensorUnitsHum;
  sToReturn += "\n</h4>\n";

  sToReturn += "<p>And the two temperatures monitored were...\n<\p>\n";
  sToReturn += "<h4>&emsp;&emsp;";
  sToReturn += udrSensorDataLocal.fTture0;
  sToReturn += " and ";
  sToReturn += udrSensorDataLocal.fTture1;
  sToReturn += " ";
  sToReturn += udrSensorDataLocal.sSensorUnitsTture;
  sToReturn += "</h4>\n";
  
  sToReturn += "<p>Passes through the loop since device booted: ";
  sToReturn += iPasses;
  sToReturn += "<br>\n\n<br>&emsp;&emsp;(There are roughly 120 ";
  sToReturn += "passes per minute.)\n<\p>\n";

  /*... "somewhat arcane" block ends here. Also block that will
     need changes if sensors changed.....  ENDS ================== */

  sToReturn += "\n<br>\n<hr>\n";
  sToReturn += "<h3>Visit https://wywtk.com for many reasons!</h3>\n\n";  

  sToReturn += "<p>For tech support, and How You Could Make a Data Sender\n";  
  sToReturn += "like the one that feeds this, visit <a href=""https://bit.ly/InfoByPcID"" \n";  
  sToReturn += "target=""_blank"">https://bit.ly/InfoByPcID</a>, (which takes you \n";
  sToReturn += "to <a href=""https://wywtk.com/fw/du/by-pc-id.htm"" target=""_blank"">";  
  sToReturn += "https://wywtk.com/fw/du/by-pc-id.htm</a>).</p>\n\n";
  
  sToReturn += "<p>It wouldn't be a trivial project to make one of these for\n";
  sToReturn += "yourself... and would only cost about $40, if that.<br>\n";
  sToReturn += "You would need either admirable stubborness, or significant\n";
  sToReturn += "prior knowledge of doing things on a LAN, and making webservers\n";
  sToReturn += "visible to 'the world'... if you wanted to go  that far.<br>\n";
  sToReturn += "Creating a sensor that can be read across your LAN wouldn't\n";
  sToReturn += "be a huge challenge.</p>\n\n";

  /*
  sToReturn += "<p>\n";
  sToReturn += "\n";
  sToReturn += "\n";
  sToReturn += "\n";
  sToReturn += "</p>\n\n"; */

  sToReturn += "<p>If the programmer who ""filled"" the device with code remembered/chose to\n";
  sToReturn += "update some important lines of the code first, you are looking at a page from:</p>\n\n";
  sToReturn += "<p>Device: "+sInstance+"<br>\n";
  sToReturn += "Running program: "+sPrgmName+"<br>\n";
  sToReturn += "In it's "+sVersID+" version</p>\n\n";
  sToReturn += "\n</body>\n";
  sToReturn += "</html>\n";
   return sToReturn;
  //Serial.println("Message built");
}  //end of Srting sBuildMessage

//==== voids ==  ========================================
//=======================================================
void ConnectWiFi(){
/*This, 08 Sep 18, not working well... fairly consisently
 the 8266 fails to connect to LAN when auto-booted post
 upload, even though turning off/ turning on again a
 a moment later gives... every time? often, anyway...
 a successful connection to the WiFi.
     ^ ^ ^ 
 The above was before I added 25 Feb 23, the...
    while (WiFi.status()!=WL_CONNECTED)
 ...loop. I suspect that will cure the old problem. 
 */

/*DOES ARDUINO ALLOW "local" SUBROUTINES?
boUsingFirstSet could go here.
*/

/*===START section "This block might better be in a SR"---*/

/* This looks complicated, even though it isn't, really.
 Messy? "Busy"? Maybe. It arises out of creating a way to
 have two sets of wifi creds, etc, "in" the device, selectable
 just by inserting or removing a link before booting.*/

//Init, in hopes that "set B" will be chosen, in which case... job done! (^_^)*/
String sWiFiSSIDLocal=WiFiSSIDb,sWiFiPSKLocal=WiFiPSKb,sSetInUse=kSet2Label;

byte bLIPA0u=bLIPA0b;  byte bLIPA1u=bLIPA1b;  byte bLIPA2u=bLIPA2b;  byte bLIPA3u=bLIPA3b;  
byte bGate0u=bGate0b;  byte bGate1u=bGate1b;  byte bGate2u=bGate2b;  byte bGate3u=bGate3b;  
byte bMask0u=bMask0b;  byte bMask1u=bMask1b;  byte bMask2u=bMask2b;  byte bMask3u=bMask3b;  
/*iPortU is set, used, elsewhere.*/

/*At this point, all of the user creds, etc, things, are set to "B" Set*/
if (boUseFirstSetofCreds()) //if h/w link says "use A"...
  // ...then change all to "A" set...
 {sWiFiSSIDLocal=WiFiSSIDa;sWiFiPSKLocal=WiFiPSKa;sSetInUse=kSet1Label;
  bLIPA0u=bLIPA0a;bLIPA1u=bLIPA1a;bLIPA2u=bLIPA2a;bLIPA3u=bLIPA3a;  
  bGate0u=bGate0a;bGate1u=bGate1a;bGate2u=bGate2a;bGate3u=bGate3a;  
  bMask0u=bMask0a;bMask1u=bMask1a;bMask2u=bMask2a;bMask3u=bMask3a;
  } //end of if... (then)... clause. No else clause is needed.
     
//---END "This block might better be in a SR"===

  //Set WiFi mode to station (as opposed to AP or AP_STA)
  WiFi.mode(WIFI_STA);
     
  Serial.println();
  Serial.print("Connecting to Wifi, using ");
  Serial.print(sSetInUse);
  Serial.print(" of creds. (ssid:");
  Serial.print(sWiFiSSIDLocal);
  Serial.println(")...");

  #ifdef VerboseMessagesOn
  //To take this block out of your code, rem out the #Define VerboseMessagesOn at the top
  //  of the page
  Serial.println("-----------");
  Serial.println("STARTs HERE: messages which only arise if boVerboseMMsgsWanted=true");
    
  Serial.print("LIPA: ");
  //In next... won't work if first byte-type variable not forced to String...
  //  to direct the call to the right overload, perhaps? (AFTER that you
  //  CAN have a mixture.
  //Following possible wheeze WON'T work!...
  //Serial.println(" "+bLIPA0u+"."+bLIPA1u+"."+bLIPA2u+"."+bLIPA3u);
  Serial.println(String(bLIPA0u)+"."+bLIPA1u+"."+bLIPA2u+"."+bLIPA3u);
  Serial.print("Port: ");
  Serial.println(String(iPortU));
  //Serial.println(sWiFiPSKLocal);//Putting this on the Serial Monitor is
  //  probably a Bad Idea... but this is how, if you feel you need to.
/*Serial.println("");
  Serial.println("");
  */
  Serial.println("ENDs HERE: Block of messages which only arises ");
  Serial.println("        if boVerboseMMsgsWanted=true ENDs HERE");
  Serial.println("        -----------");
  Serial.println();
#endif VerboseMessagesOn

  //WiFI.begin([ssid], [passkey]) initiates a WiFI connection
  //   to the stated [ssid], using the [passkey] as a WPA, WPA2,
  //   or WEP passphrase.
  //
  WiFi.begin(sWiFiSSIDLocal,sWiFiPSKLocal);
  /*Failure to connect handling should be present here... a task for later.
  pp the excellent...
  https://alselectro.wordpress.com/2016/11/29/esp8266-wifi-library-on-arduino-ide/ 
  ... the possible return values are
  WL_CONNECTED        after successful connection is established with the Access Point
  WL_IDLE_STATUS      when Wi-Fi is in process of changing between statuses
  WL_NO_SSID_AVAIL    in case configured SSID cannot be reached
  WL_CONNECT_FAILED   if password is incorrect
  WL_DISCONNECTED     if module is not configured in station mode*/

  iTmp=0;
  //At this point, LED should already be off, but, just to be sure...
  LedTurnOff(pinMsgsByLedFlash,boMakeHiToTurnOn);
  delay(600);
  
  while (WiFi.status()!=WL_CONNECTED) {
    //Wait for preliminary connection. We are not yet connected to, or allowed
    //  to USE the LAN. So far the "doorkeeper" at the router has "said"...
    //  "You knocked? Who are you? What resources do you want? (LIPA, etc)."
    iTmp=iTmp+1;
    //No delay HERE, as their "ought" to be... but there's one shortly
    Serial.print(".");
      //Send "Wink, wink, pause", to say: "Waiting for...
         //LedWinks(int iOnTime,int iOffTime,byte bRepeat,byte bPin, boolean boMakeHiToTurnOnL);
         
         LedWinks(80,80,2,pinMsgsByLedFlash,boMakeHiToTurnOn);
         /*Serial.print("x");
         LedTurnOn(pinMsgsByLedFlash, boMakeHiToTurnOn);
         delay(80);
         LedTurnOff(pinMsgsByLedFlash, boMakeHiToTurnOn);
         delay(80);
         LedTurnOn(pinMsgsByLedFlash, boMakeHiToTurnOn);
         delay(80);
         LedTurnOff(pinMsgsByLedFlash, boMakeHiToTurnOn);
         delay(80);*/
         
         delay(900);
          
    //From time to time, start a new line of ...s on the serial monitor
    if (iTmp%18==0){Serial.println();};
    }//Do all of that until (WiFi.status()=WL_CONNECTED)

/*Begin block from https://forum.arduino.cc/index.php?topic=460595.0
See also https://arduino-esp8266.readthedocs.io/en/latest/esp8266wifi/readme.html
In particular, for our wants... ESP8266 as server (overview)...
   https://arduino-esp8266.readthedocs.io/en/latest/esp8266wifi/server-class.html
   And examples of same...
   https://arduino-esp8266.readthedocs.io/en/latest/esp8266wifi/server-examples.html
     Beware, though... that page sends you to the Arduino ref for THEIR "Wifi" if
     you click the "print()" item in the table of contents. Maybe that works as the 
     one in the ESPWifi??
(By the way... good news from first pg cited...
Note: if connection is established, and then lost for some reason, ESP will automatically reconnect to the last used access point once it is again back on-line. This will be done automatically by Wi-Fi library, without any user intervention.
We will use a static IP.
YES: This goes AFTER the WiFi.begin

See notes near top of code about why this has been done in such an arcane manner,
and about how it works. And the notes below.*/
  Serial.println();
  Serial.println("Just bef 'ipaddress()' called, bLIPA3u was "+String(bLIPA3u));
  //The db msg triggered by previous line takes a moment to appear... as it should. It
  //appears list before the output from the lines following comment "cmnt23302a"
  
  IPAddress ip(bLIPA0u,bLIPA1u,bLIPA2u,bLIPA3u);//Instance specific
  IPAddress gateway(bGate0u,bGate1u,bGate2u,bGate3u);//Instance specific  
  IPAddress subnet(bMask0u,bMask1u,bMask2u,bMask3u);//Instance specific

/*EDIT- MOVE TO RIGHT PLACE!
What's above may be "overkill", but I wanted everything that would
need tweaking to create a new instance of the device to be here near
start of code.

>> CHECK... REVISE??>>
The following determine...
  what the device's Local IP Address ("LIPA") will be. (It's IP in the LAN)
  what local IP addr is used for the device's gateway
  and the LAN's subnet mask. (All of this is IPv4 only)

bLIPA0,-1, and -2 determine the first three numbers in BOTH the
device's LIPA and that of the first three for the gateway.
(If you know of a LAN that allows these to be different, do tell!)

The final number for the device's LIPA is supplied with bLIPA3
The final number for the gateway's LIPA is supplied with bLIPA_Gateway
Not rocket science!

SubNet0,-1, -2 and -3 determine... can you guess?... the LAN's subnet mask.
*/
       
          //void LedWinks(int iOnTime,int iOffTime,byte bRepeat,
          //   byte bPin, boolean boMakeHiToTurnOn)
          LedWinks(80,60,4,pinMsgsByLedFlash,boMakeHiToTurnOn);
          /*digitalWrite(pinMsgsByLedFlash,bLEDOn);//
          delay(80);
          digitalWrite(pinMsgsByLedFlash,bLEDOff);
          delay(60);

          digitalWrite(pinMsgsByLedFlash,bLEDOn);//
          delay(80);
          digitalWrite(pinMsgsByLedFlash,bLEDOff);
          delay(60);

          digitalWrite(pinMsgsByLedFlash,bLEDOn);//
          delay(80);
          digitalWrite(pinMsgsByLedFlash,bLEDOff);
          delay(60);

          digitalWrite(pinMsgsByLedFlash,bLEDOn);//
          delay(80);
          digitalWrite(pinMsgsByLedFlash,bLEDOff);
          delay(60);
          */
          
          delay(100);
          
       delay(900);//Probably not necessary! But, won't hurt.
       //A pause here for the recent steps to "settle" means
       //  one fewer things to go wrong.
          
  WiFi.config(ip, gateway, subnet);
  //end of block from forum

  //Now use the WiFi.status() function to check if the ESP8266
  // is connected to a WiFi network.
  //Start by requesting repeatedly until successful
  while (WiFi.status() != WL_CONNECTED) {
    // Delays allow  boolean the ESP8266 to perform critical tasks
    // defined outside of the sketch. These tasks include
    // setting up and maintaining, a WiFi connection.
    //wink, wink, pause (2 winks): "Waiting for...
    
    //LedWinks(iOnTime,iOffTime,bRepeat,bPin,boMakeHiToTurnOn)
    LedWinks(100,50,3,pinMsgsByLedFlash,true);
    delay(900);
       
    LedTurnOff(pinMsgsByLedFlash,boMakeHiToTurnOn);
    // Potentially infinite loops are generally dangerous.
    // Add delays -- allowing the processor to perform other
    // tasks -- wherever possible.
       }

  //Final messages... (This comment's ID: cmnt23302a) 
  Serial.println("WiFi connected");  
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());
  Serial.print("Serving on port ");
  Serial.println(iPortU);
  
  }  //End void ConnectWiFi()

//=======================================================
void InitPinModes() {
//Remember... Feather Huzzah places some contraints on the
//  use of some GPIO pins. See...
//https://learn.adafruit.com/adafruit-sht31-d-
//         temperature-and-humidity-sensor-breakout
  pinMode(pinMsgsByLedFlash,OUTPUT);//D0 For Blink test, msgs
    //pinMsgsByLedFlash, a system name, drives the red LED on the Huzzah
  
  pinMode(pinAlwaysLow,OUTPUT);//Set LOW, as sink for inputs
  digitalWrite(pinAlwaysLow,LOW);
  
  pinMode(pinSelectWifi,INPUT_PULLUP);//Change state to change
    //which of the two hardcoded sets of wifi creds s used.
    //  *link to 0v  -OR- *leave open BEFORE device
    //   is reset. You can't change creds without a reset.
    //See ConnectWiFi()

//  pinMode(pin,INOUTPUT);//
}  //end void InitPinModes() 

//=======================================================
void SendReadingsToSerialMonitor(TudrSensorData udrSensorDataL) {
//If sensors in system change, the inner parts of the following
//   will need changes.

   //Don't include t"Serial.print(iPassesSinceStrt);" here...
   //  it is already part of loop(): 
   //General rule, Serial.print: You can "mix" strings with +'s, but
   //  not a number and a string...
   //  Allowed: Serial.print(udrSensorDataL.sSensorUnitsTture+", ");
   //      Not: Serial.print(udrSensorDataL.fTture0+" ");
   Serial.print(" Tture on 40, then 41: "); 
   Serial.print(udrSensorDataL.fTture0);
   Serial.print(" ");
   Serial.print(udrSensorDataL.sSensorUnitsTture+", ");
   Serial.print(udrSensorDataL.fTture1);
   Serial.print(" "+udrSensorDataL.sSensorUnitsTture+" // ");
      
   Serial.print("Humidity on 40, then 41: ");
   Serial.print(udrSensorDataL.fHum0);
   Serial.print(udrSensorDataL.sSensorUnitsHum+", ");
   Serial.print(udrSensorDataL.fHum1);
   Serial.println(udrSensorDataL.sSensorUnitsHum);   
}  // end void SendReadingsToSerialMonitor(
     
//=======================================================
void SendWelcomeAndDocumentationToSerialMonitor() {
Serial.println();
Serial.println();
Serial.print("Welcome to ");Serial.println(sPrgmName);
Serial.println("      from https://wywtk.com");
Serial.print("Instance: ");Serial.println(sInstance);
Serial.print("Version: ");Serial.println(sVersID);
Serial.print("Serial monitor needs to be run at ");
   Serial.print(iSerialBaud);Serial.println(" baud.");
Serial.println("Hardware: Feather Huzzah 8266");
Serial.println("  2x Adafruit HTU31-D modules, part number 4832");
Serial.println(" Feather Huzzah pins...");
Serial.println("  The are notes about the Huzzah's use of");
Serial.println("    several of the pins. for those, see...");
Serial.println("    https://learn.adafruit.com/adafruit-");
Serial.println("      -d-temperature-and-humidity-sensor-breakout");
Serial.println("  Adafruit made special circumstances for 0,2,15 and 16.");
Serial.println("  --- ar787, the code that is preducing this message,");
Serial.println("      uses the following as indicated below.");
Serial.println("      (I say 'D2' where Adafruit says 'GPIO 2'.)");
Serial.println("  D0 is left simply driving the onboard LED; no other use");
Serial.println("  D15 made an always-low input, as a 'sink' for link-options");
Serial.println("  D14 is an input. The internal pull-up is active. Pull low");
Serial.println("   (by connecting to GND... or to D15, which is held low) to");
Serial.println("    use the second of the two sets of wifi creds held");
Serial.println("  N.B.: On the Feather, the pins are NOT brought out in 1,2,3... order");
Serial.println("    in device. Having no link will select the 1st set.");
//I tried using D16 as the input, but couldn't pull it low. 15 pulled 14 low,
//no problems. (I set 14 to be an input pulled up by configuring it INPUT_PULLUP)
//15 is an output, set to 0v. You could use the board's 0v... but MECHANICALLY, a
//link between 14 and 15 is easy. (They are NOT adjacent, but nearly so.)
Serial.println("  ");
Serial.println("  ");

Serial.println("       Think, though: If you use the LED to send msgs about");
Serial.println("       the state of the device, that signal could be turned");
Serial.println("       into an AUDIBLE message, too. (Multiple 'messages'");
Serial.println("       can be achieved with different PATTERNs of flashing.)");
Serial.println("  ");
Serial.println("  ");
Serial.println("  TX/RX left for just their roles connecting to the IDE,");
Serial.println("     including communication with the Serial Monitor.");
Serial.println("  D4, D5: Only used for I2C SDA/SCL... Feather's default");
Serial.println("  pins for these signals.");
Serial.println();
Serial.println("Software (In addition to basic libraries for the board):");
Serial.println("  Adafruit_HTU31D.h: For the Adafruit temperature/humidity");
Serial.println("     sensor. Use Tools/ Manage Libraries to install. See ");
Serial.println("     https://github.com/adafruit/Adafruit_HTU31D");
Serial.println("     if more help needed.");
Serial.println("  ESP8266WiFi.h: For the wifi");
Serial.println();
Serial.println("Configuration:");
Serial.println("  A number of things need to be hardcoded for your");
Serial.println("     requirements. All such are flagged 'Instance specific'");
Serial.println("     E.g. the two SETS of wifi creds 'in' the device.");
Serial.println("  (But there are link-slectable options in some cases...");
Serial.println("     E.g. which set of the two wifi creds 'inside' the device");
Serial.println("        are used.");
//Serial.println("     ");
Serial.println("-----------");
Serial.println("The cable between the sensors is CRITICAL. Keep short.");
Serial.println("Twisted pairs. If device isn't working, it is probably the");
Serial.println("cable... especially if the near sensor can be seen, but");
Serial.println("not the distal one.");
Serial.println("-----------");
//I WANT to ADD NOTES ABOUT THE LED WINK CODES
}  //end void SendWelcomeAndDocumentationToSerialMonitor(

//======================================================= End of the whole page.
